﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using UnityEngine;
using UnityEngine.Events;


namespace Mod
{
    public class Mod
    {

        public static void Main()
        {
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Tesla Coil"), // derive from a syringe
                    NameOverride = "Uncharted Territory Portal",
                    DescriptionOverride = "Open uncharted territory portal.",
                    CategoryOverride = ModAPI.FindCategory("Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprite.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<UTP>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite.png");
                        Instance.FixColliders();

                    }
                }
            );
        }
    }
    public class UTP : MonoBehaviour
    {
        public void Use()
        {
            ExplosionCreator.Explode(new ExplosionCreator.ExplosionParameters
            {
                Position = gameObject.transform.position,
                CreateParticlesAndSound = true,
                LargeExplosionParticles = true,
                DismemberChance = 0.5f,
                FragmentForce = 5,
                FragmentationRayCount = 32,
                Range = 50
            });
            var tcb = gameObject.GetComponent<TeslaCoilBehaviour>();
            var portal = tcb.Wh;
            UnityEngine.Object.Instantiate<GameObject>(portal, gameObject.transform.position, Quaternion.identity);
            GameObject.Destroy(gameObject);
        }
    }
}
